# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nikolay Kim <fafhrd@legco.biz>
"""
$Id: CacheHooks.py,v 1.3 2004/04/15 17:40:22 fafhrd91 Exp $
"""

import traceback
from Acquisition import aq_parent, aq_inner, aq_base
from debug import log_exc

class CacheHooks:

    _cache_invalidates = {}

    def update_cache(self, hookId='', **kwargs):
        hint = self.getPhysicalPath()
        
        views = self._cache_invalidates.get(hookId, [])
        for view in views:
            view_ob = getattr(self, view, None)

            if view_ob is not None:
                manager = view_ob.ZCacheable_getManager()
                if manager is not None:
                    cache = manager.ZCacheManager_getCache()
                    if cache is not None:
                        try:
                            cache.ZCache_invalidate_by_hint(view_ob, hint)
                        except:
                            traceback.print_exc()

        try:
            parent = aq_parent(aq_inner(self))
            if (parent is not None) and (hasattr(aq_base(parent), 'update_cache')):
                parent.update_cache(hookId, **kwargs)
        except:
            log_exc()
