# -*- Mode: Python; py-indent-offset: 4 -*-
# * Copyright (C) Nikolay Kim <fafhrd@legco.biz> 

import traceback
from Acquisition import aq_base, aq_parent
from cStringIO import StringIO
from Products.CMFBoard.DiscussionTool import ForumDiscussionTool
from Products.CMFBoard.ForumContentTopic import ForumContentTopic

def convert(self):
    out = StringIO()

    ctool = self.portal_catalog
    dtool = self.portal_discussion
    if dtool.meta_type != ForumDiscussionTool.meta_type:
        raise Exception, 'Wrong portal_discussion'
    atool = self.archetype_tool

    tps = []
    for tp in self.portal_types.listTypeInfo():
        tp_name = tp.Title()
        if tp_name != 'Discussion Item':
            tps.append(tp_name)

    # check all content
    for brain in ctool(Type=tps):
        try:
            ob = brain.getObject()
        except:
            continue
            
        if ob is not None:
            talkback = getattr(ob, 'talkback', None)
            if (talkback is not None) and talkback.hasReplies(ob):
                tp_name = ob.getPortalTypeName()

                # get destination forum 
                forum_uid = dtool.TypeForum(tp_name)
                if not forum_uid:
                    forum_uid = dtool.DefaultForum()
                forum = atool.lookupObject(forum_uid)
                if forum is None:
                    raise Exception, "Can't found destination forum for type '%s'"%tp_name

                # create topic
                topic = forum.manage_addTopic(
                    'discussion', '', language=ob.Language(),
                    portal_type=ForumContentTopic.meta_type,
                    content_path='/'.join(ob.getPhysicalPath()))

                def process_reply(reply, parent=None):
                    for r in talkback.__of__(reply).getReplies():
                        # add reply
                        if parent:
                            try:
                                reply_to = parent.UID()
                            except:
                                reply_to = ''
                        else:
                            reply_to = ''

                        # create reply duplicate
                        msg = topic.manage_addReply(
                            r.title, r.text, reply_to=reply_to)
                        msg.creation_date = r.created()
                        msg.modification_date = r.modified()
                        msg.creator = r.Creator()
                        msg.reindexObject()
                           
                        process_reply(r, msg)

                process_reply(ob)

                # update topic attrs
                topic.creation_date = ob.created()
                topic.modification_date = ob.modified()
                topic.creator = ob.Creator()
                topic.reindexObject()

                ob.talkback.manage_beforeDelete(ob.talkback, ob)
                ob.talkback = topic.UID()

    print >> out, "Successfully converted from default discussion to CMFBoard."

    return out.getvalue()
