# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
"""
$Id: ForumPermissions.py,v 1.12.6.4 2005/01/24 12:47:24 fafhrd91 Exp $
"""

from Products.CMFCore.CMFCorePermissions import *

forumManager = 'Forum manager'
forumReviewer = 'Reviewer'
forumReader = 'Forum reader'
forumWriter = 'Forum writer'
replyWriter = 'Reply writer'
topicManager = 'TopicManager'
topicOwner = 'TopicOwner'

forumRoles = (forumManager, topicManager, forumReviewer,
              forumReader, forumWriter, replyWriter, topicOwner)

setDefaultRoles( View, ( 'Manager', 'Forum Manager', 'Reader' ))
setDefaultRoles( ModifyPortalContent, ( 'Manager', forumManager, topicManager ))

AddTopic = 'CMFBoard: Add forum topic'
setDefaultRoles( AddTopic, ( 'Manager', forumManager, forumWriter ))

AddTopicReply = 'CMFBoard: Add forum topic reply'
setDefaultRoles( AddTopicReply, ( 'Manager', forumManager, forumReviewer, replyWriter ))

AddPoll = 'CMFBoard: Add forum poll'
setDefaultRoles( AddPoll, ( 'Manager', forumManager, forumWriter))

AddAnnouncement = 'CMFBoard: Add forum announce'
setDefaultRoles( AddAnnouncement, ( 'Manager', forumManager, forumReviewer))

ManageForum = 'CMFBoard: Manage forum'
setDefaultRoles( ManageForum, ( 'Manager', forumManager ))

ManageTopic = 'CMFBoard: Manage forum topic'
setDefaultRoles( ManageTopic, ( 'Manager', forumManager, topicManager, forumReviewer))

ModifyTopic = 'CMFBoard: Modify forum topic'
setDefaultRoles( ModifyTopic, ( 'Manager', forumManager, topicManager))

ModifyAttachments = 'CMFBoard: Modify attachements'
setDefaultRoles( ModifyAttachments, ( 'Manager', forumManager, topicManager, 'Owner'))

ViewAdminTopic = 'CMFBoard: View admin topic'
setDefaultRoles( ViewAdminTopic, ( 'Manager', forumManager, forumReviewer))

DeleteTopic = 'CMFBoard: Delete forum topic'
setDefaultRoles( DeleteTopic, ( 'Manager', forumManager, topicManager))

DeleteReply = 'CMFBoard: Delete forum reply'
setDefaultRoles( DeleteReply, ( 'Manager', forumManager, topicManager))
