# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nikolay Kim <fafhrd@datacom.kz> 

from ExtensionClass import Base
from Acquisition import aq_base
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

class IdGenerator(Base):

    security = ClassSecurityInfo()

    _last_id = 0

    security.declarePrivate('getNextId')
    def getNextId(self):
        """ return next generated id, unique for this object """
        free_self = aq_base(self)

        id = getattr(free_self, '_last_id', 0) + 1
        self._last_id = id

        return '%0.4d'%id
    
    security.declarePrivate('getLastId')
    def getLastId(self):
        return '%0.4d'%self._last_id

InitializeClass(IdGenerator)
