# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: SizeValidator.py,v 1.7.6.2 2005/01/24 12:47:40 fafhrd91 Exp $
"""

import traceback
from Products.Archetypes.public import *
from Products.validation import validation
from Products.validation.interfaces import ivalidator

class TextSizeValidator:
    __implements__ = (ivalidator,)
    
    def __init__(self, name):
        self.name = name
        
    def __call__(self, value, *args, **kwargs):
        inst = kwargs['instance']

        forum = inst.getForum()
        size = forum.getField('text_size').get(forum)

        try:
            if size < len(value):
                return 'Max size exceeded.'
        except:
            pass

        return 1

validation.register(TextSizeValidator('checkTextSize'))


class AttachmentSizeValidator:
    __implements__ = (ivalidator,)
    
    def __init__(self, name):
        self.name = name
        
    def __call__(self, value, *args, **kwargs):
        inst = kwargs['instance']

        forum = inst.getForum()
        size = forum.getField('attachment_size').get(forum)

        try:
            total_size = 0
            for val in inst.contentValues():
                total_size += val.get_size()

            try:
                total_size += len(value.read())

                try:
                    value.seek(0)
                except:
                    pass
            except:
                try:
                    total_size += len(value)
                except:
                    pass
                
            if size < total_size:
                return 'Max size exceeded.'
        except:
            pass

        return 1

validation.register(AttachmentSizeValidator('checkAttachmentSize'))
