__version__ = '$Revision: 1.33.6.5 $'[11:-2]

import Globals
from Globals import package_home
from AccessControl import ModuleSecurityInfo, allow_module
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import View, ManagePortal, AddPortalContent
import Products.CMFCore.utils as cmfcore_utils

from config import SKINS_DIR, GLOBALS, PROJECTNAME

registerDirectory(SKINS_DIR, GLOBALS)

import CacheManager, CacheManagerMisc
import ForumWorkflow, SizeValidator, UtilitiesTool, mailtemplates

import traceback

def initialize(context):
    import Forum, ForumTopic, ForumFolder, ForumTopic, ForumPoll
    import ForumContentTopic, ForumMessage, ForumAttachment
    import DiscussionTool, DiscussionFilter
    
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    cmfcore_utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = AddPortalContent,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    cmfcore_utils.ToolInit(
        PROJECTNAME + ' Tools'
        , tools = (DiscussionTool.ForumDiscussionTool,
                   DiscussionFilter.ForumDiscussionFilter,
                   UtilitiesTool.UtilitiesTool,
                   )
        , product_name = PROJECTNAME
        , icon='tool.gif'
        ).initialize(context)


    context.registerClass(
        CacheManager.CMFBoardCacheManager,
        constructors = (CacheManager.manage_addCMFBoardCacheManagerForm,
                        CacheManager.manage_addCMFBoardCacheManager),
        icon="cache.gif"
        )

    context.registerClass(
        CacheManagerMisc.RAMCacheManagerMisc,
        constructors = (CacheManagerMisc.manage_addRAMCacheManagerMiscForm,
                        CacheManagerMisc.manage_addRAMCacheManagerMisc),
        icon="cache.gif"
        )


from striphtml import strip
from utils import forum_parser, forum_html_tidy

methods = {'cbForum_striphtml': strip,
           'cbForum_parser': forum_parser,
           'cbForum_html_tidy': forum_html_tidy,
           }

allow_module('Products.CMFBoard.utils')
ModuleSecurityInfo('Products.CMFBoard.utils').declareProtected(View, 'forum_stateChanged')

try:
    import forum_export, forum_import

    ModuleSecurityInfo('Products.CMFBoard.forum_export').declareProtected(ManagePortal, 'forum_export')
    ModuleSecurityInfo('Products.CMFBoard.forum_import').declareProtected(ManagePortal, 'forum_import')
    allow_module('Products.CMFBoard.forum_export')
    allow_module('Products.CMFBoard.forum_import')
except:
    pass
