# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.kz> 
"""
$Id: config.py,v 1.68.4.3.2.7 2005/05/23 17:35:00 fafhrd91 Exp $
"""

import os
from Globals import package_home
from Products.CMFCore.CMFCorePermissions import \
     AddPortalContent, ModifyPortalContent, ManagePortal
from Products.Archetypes.public import *
from ForumPermissions import *

# for checking migration
INTERNAL_VERSION = (2, 2)

GLOBALS = globals()

_zptdir = os.path.join(package_home(globals()), 'zpt')

ADD_CONTENT_PERMISSION = AddPortalContent
PROJECTNAME = 'CMFBoard'
SKINS_DIR = 'skins'
CMFBOARD_TOOL = 'portal_cmfboard'
CACHE_ID = 'CMFBoardCache'
CACHE_ID2 = 'CMFBoardCache2'
MAILTEMPLATES_DIR = os.path.join(package_home(globals()), 'mailtemplates')

error_templates = {
    1: 'forum_error_1',
    2: 'forum_error_2',
    3: 'forum_error_3',
    4: 'forum_error_4',
    5: 'forum_error_5'
    }

# hits counter
hc_dir = 'CMFBoard'
hc_use_instance = 1

ploneOldSkin = 'cmfboard/fcPloneOld'
discussionSkin = 'cmfboard/fcDiscussion'

portlets = (
    'here/portlet_forum_latest/macros/portlet',
    'here/portlet_forum_poll/macros/portlet',
    )
#'here/forumRejected_slot/macros/portlet',
#'here/forumSubmitted_slot/macros/portlet',


menu_portlets = (
    'here/forum_topic_menu_portlet/macros/portlet',
    'here/forum_menu_portlet/macros/portlet',
    )

cmfboard_properties = (
    ('allow_signatures', 'boolean', 1),
    ('allow_outside_forumnb', 'boolean', 0),
    ('view_mode_selectable', 'boolean', 1),
    )

memberData_properties = (
    ('fc_posts', 'int', 0),
    ('fc_autosubscribe', 'boolean', 0),
    ('fc_emailtome', 'boolean', 1), # can other members email to me
    ('fc_forum_vm', 'string', 'flat'), # view mode for forum
    ('fc_topic_vm', 'string', 'flat'), # view mode for topic
    ('fc_topic_sm', 'string', 'older_first'), # sort mode for topic
    ('fc_mail_format', 'string', 'plain'), # mail format plain or html

    ('location', 'string', ''),
    ('occupation', 'string', ''),
    ('interests', 'string', ''),
    ('homepage', 'string', ''),
    ('timezone', 'string', ''),
    ('signatures', 'lines', []),

    ('im_icq', 'string', ''),
    ('im_jabber', 'string', ''),
    ('im_yahoo', 'string', ''),
    ('im_msn', 'string', ''),
    ('im_aim', 'string', ''),
    ('im_ichat', 'string', ''),

    ('show_email', 'boolean', 0),
    ('show_im', 'boolean', 1),
    ('show_fullname', 'boolean', 0),
    )

memberData_deprecated = ('fc_internal_data', 'string',)

topicTypes = {
    1: 'regular',
    2: 'admin',
    3: 'announce',
    }
topicTypeList = topicTypes.keys()

forum_preferences = {
    'id': 'CMFBoard_member_prefs',
    'appId': PROJECTNAME,
    'name': 'Forum preferences',
    'action': 'string:$portal_url/prefs_contact_info',
    'condition': 'not:object/portal_membership/isAnonymousUser',
    'permission': ('View',),
    'category': 'Member',
    'imageUrl': 'fcForum_icon.gif',
    }

cmfboard_configlet = {
    'id': 'CMFBoard_configuration',
    'appId': PROJECTNAME,
    'name': 'CMFBoard configuration',
    'action': 'string:$portal_url/prefs_cmfboard_form',
    'category': 'Products',
    'permission': (ManagePortal,),
    'imageUrl': 'fcFolder_icon.gif',
    }

discussion_configlet = {
    'id': 'CMFBoard_discussion',
    'appId': PROJECTNAME,
    'name': 'CMFBoard Discussion tool configuration',
    'action': 'string:$portal_url/prefs_cmfboard_dtool_form',
    'category': 'Products',
    'permission': ('Manage portal',),
    'imageUrl': 'fcFolder_icon.gif',
    }


role_map = {
    0:forumManager,1:forumReviewer,2:forumWriter,3:replyWriter,4:forumReader }

view_modes = DisplayList([
    ('flat', 'Flat'),
    ('nested', 'Nested'),
    ('thread','Thread')])

quickreply_forms = DisplayList([
    ('', 'Not use'),
    ('here/forum_quickreply_form/macros/edit_form', 'Simple form'),
    ('here/forum_blog_widget/macros/blog_form', 'Full form'),
    ])

wysiwyg_editors = DisplayList([
    ('', 'Member Default'),
    ('None', 'Ordinary Form-based Editor')])

parsing_flags = DisplayList([
    ('', 'User defined'),
    ('on', 'Always ON'),
    ('off', 'Always OFF'),
    ])

roles_attache = DisplayList(
    (('Anonymous', 'Anonymous'),
     ('Member', 'Member'),
     ('Manager', 'Manager'),
     ('Forum manager', 'Forum manager'),
     ('Forum writer','Forum writer'),
     ('Reply writer','Reply writer'),
     ))

predefined_skins = DisplayList(
    (('', 'Default'),
     ('cmfboard-1X', 'CMFBoard 1.x'),
     #('minimal', 'CMFBoard Minimal'),
     #('cmfboardBlog', 'Web Blog'),
     ))

predefined_skins_path = (
    ('cmfboard-1X', ('cmfboard/cmfboard-1X',)),
    )
    

anon_name_modes = DisplayList([
    ('', 'Off'),
    ('on', 'On'),
    ('required', 'Name required'),
    ])

# icons
icons = {}

# disallow discussion for this content type
filtered_discussion_types = (
    'ForumAttachment',
    'ForumContentMessage',
    'ForumContentTopic',
    'ForumFolder',
    'ForumMessage',
    'ForumNB',
    'ForumPoll',
    'ForumTopic',
    'DTML_MailTemplate',
    'PT_MailCategory',
    'PT_MailTemplate',
    'Simple_MailTemplate',
    'TempFolder',
    'Discussion Item',
    )
