# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: __init__.py,v 1.1.2.1 2005/05/24 20:07:36 fafhrd91 Exp $
"""

from zLOG import LOG, ERROR
from Products.CMFBoard.config import PROJECTNAME, MAILTEMPLATES_DIR

def readfile(filename):
  """ returns file data in a string"""
  
  data = ''
  try:
    file = open(MAILTEMPLATES_DIR + '/' + filename, mode='r')
    for line in file:
      data += line   
    file.close()
  except:
    LOG(PROJECTNAME, ERROR, 'Cannot open %s'%MAILTEMPLATES_DIR + '/' + filename)

  return data

forum_message_plain = {'title':'Forum Message (plain)',
                       'mail_subject': 'string:${options/message_title}',
                       'mail_body': readfile('forum_message_plain.zpt'),
                       }


forum_message_html = {'title':'Forum Message (html)',
                      'mail_subject': 'string:${options/message_title}',
                      'mail_body': readfile('forum_message_html.zpt'),
                      }


forum_moderated_message = {'title': 'Moderated message',
                           'mail_subject': "python:here.translate('text_your_message',default='Your message to') + options['forum_title'] + here.translate('text_awaits_approval', defaul='awaits moderator approval.')",
                           'mail_body': readfile('forum_moderated_message.zpt'),
                           }

forum_error_1 = {'title': 'Error 1',
                 'description': "User don't have permission to add new topic.",
                 'mail_subject': "python:here.translate('error_perm_add_topic', default='Error (Add new topic)')",
                 'mail_body': readfile('forum_error_1.zpt'),
                 }

forum_error_2 = {'title': 'Error 2',
                 'description': "User are not subscribed.",
                 'mail_subject': "python:here.translate('error_not_subscribed', default='Error (Not Subscribed)')",
                 'mail_body': readfile('forum_error_2.zpt'),
                 }


forum_error_3 = {'title': 'Error 3',
                 'description': "Topic not found.",
                 'mail_subject': "python:here.translate('error_topic_not_found', default='Error (Topic not found)')",
                 'mail_body': readfile('forum_error_3.zpt'),
                 }


forum_error_4 = {'title': 'Error 4',
                 'description': "User don't have permission to add reply.",
                 'mail_subject': "python:here.translate('error_perm_add_new_reply',default='Error (Add new reply)')",
                 'mail_body': readfile('forum_error_4.zpt'),
                 }

templates = {
    'CMFBoard':
    {'attributes': {'title':'CMFBoard mail templates',
                    'fields':[],},
     'templates': {'forum_message_plain': forum_message_plain,
                   'forum_message_html': forum_message_html,
                   'forum_moderated_message': forum_moderated_message,
                   'forum_error_1': forum_error_1,
                   'forum_error_2': forum_error_2,
                   'forum_error_3': forum_error_3,
                   'forum_error_4': forum_error_4,
                   }
     }
    }
