## Script (Python) "forum_poll_vote"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=vote=None, unvote=None, answer=None
##title=Vote
##

msg = 'Your vote has been registered.'
vote_result = context.getVote()

if context.isOpen():
    if vote:
        minimum_answers = context.getMinimum_answers()
        maximum_answers = context.getMaximum_answers()
        answers_len = 0
        
        if same_type(answer, ()) or same_type(answer, []):
            answers_len = len(answer)
        elif answer:
            answers_len = 1
        
        if minimum_answers > answers_len or maximum_answers < answers_len:
            msg = 'You must choose %s minimum answer(s) and %s maximum.' % (str(minimum_answers), str(maximum_answers))
            return state.set(status='failure', portal_status_message=msg)
        elif minimum_answers == maximum_answers and minimum_answers != answers_len:
            msg = 'You must choose %s answer(s).' % str(minimum_answers)
            return state.set(status='failure', portal_status_message=msg)

        if vote_result:
            msg = 'You have already voted in this poll.'
            return state.set(status='failure', portal_status_message=msg)
        else:
            context.vote(answer)    
    elif unvote:
        if not vote_result:
            msg = 'You haven\'t voted in this poll.'
            return state.set(status='failure', portal_status_message=msg)
        else:    
            context.unvote()
            msg = 'Your vote has been unregistered.'
else:
    msg = 'This poll is closed.'
    return state.set(status='failure', portal_status_message=msg)

return state.set(status='success', portal_status_message=msg)
