# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
from Products.CMFCore.utils import getToolByName

default_smiles = (
    (':cool:', 'cbs_cool.gif'),
    (':mad:', 'cbs_mad.gif'),
    (':grin:', 'cbs_grin.gif'),
    (':huh:', 'cbs_huh.gif'),
    (':laugh:', 'cbs_laugh.gif'),
    (':wacko:', 'cbs_wacko.gif'),

    (':(', 'cbs_sad.gif'),
    (':-(', 'cbs_sad.gif'),
    (':sad:', 'cbs_sad.gif'),

    (':)', 'cbs_smile.gif'),
    (':-)', 'cbs_smile.gif'),
    (':smile:', 'cbs_smile.gif'),

    ('8)', 'cbs_madlaugh.gif'),
    ('8-)', 'cbs_madlaugh.gif'),
    (':madlaugh:', 'cbs_madlaugh.gif'),

    (';)', 'cbs_wink.gif'),
    (';-)', 'cbs_wink.gif'),
    (':wink:', 'cbs_wink.gif'),
    
    (':love:', 'cbs_love.gif'),
    (':oops:', 'cbs_oops.gif'),
    (':disgust:', 'cbs_disgust.gif'),
    (':zz:', 'cbs_zz.gif'),
    (':hm:', 'cbs_hm.gif'),
    )


def parse_smiles(context, text):
    for sm, sm_img in default_smiles:
        try:
	    # fixme: need pass portal var into this func for speedup
            portal = getToolByName(context, 'portal_url')
            text = text.replace(sm, getattr(portal.getPortalObject(), sm_img).tag())
        except:
            pass
            
    return text


import os
from debug import log
from config import icons

from Products.CMFCore import DirectoryView


base_dir = os.path.join('', 'CMFBoard', 'skins', 'cmfboard_images', 'fcIconsExt')
base_dir_len = len(base_dir)

dirs = []
for dir in DirectoryView._dirreg.listDirectories():
    if dir.startswith(base_dir):
        dirs.append(dir)

for dir in dirs:
    prefix = dir[base_dir_len:]
    
    info = DirectoryView._dirreg.getDirectoryInfo(dir)

    obs, mts = info.getContents(DirectoryView._dirreg)

    for key, ob in obs.items():
        if hasattr(ob, 'icon_id'):
            id = ob.icon_id
            title = ob.title
            
            path = 'fcIconsExt%s/%s'%(prefix, ob.id)

            if icons.has_key(id):
                log('Icon with id "%s" already exists.'%id)
                continue

            if icons.has_key(title):
                log('Icon with title "%s" already exists.'%title)

            icons[id] = {'prefix': prefix[1:], 'path':path, 'icon': id,
                         'width': ob.width, 'height': ob.height, 'title': title,
                         'id': 1}
            icons[title] = {'prefix': prefix[1:], 'path':path, 'icon': id,
                            'width': ob.width, 'height': ob.height, 'title': title,
                            'id': 0}


icons_cats = {}

for key, val in icons.items():
    if val['id']:
        m = icons_cats.setdefault(val['prefix'], {})
        m[key] = val
