# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
"""
$Id: ForumView.py,v 1.10.2.2 2005/05/24 20:07:38 fafhrd91 Exp $
"""

from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import _checkPermission
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFBoard.ForumPermissions import *

from ui_get_forum_data import get_forums_tree

class ForumView:

    security = ClassSecurityInfo()

    def view_getGlobals(self, request):
        uid = self.UID()
        tool = request.cmfboard_tool

        data = tool.getView(uid, 'globals')
        if data:
            return data
        
        data = {}
        
        forum_url = self.absolute_url()

        data['new_topic_url'] = '%s/forum_add_topic_form'%forum_url

        data['uid'] = self.UID()
        data['url'] = forum_url
        data['title'] = self.Title()
        data['moderated'] = self.moderated
        data['show_parsingflag'] = getattr(self, 'parsing_flag', 1)
        data['show_userinfo'] = getattr(self, 'show_userinfo', 1)
        data['show_wizards'] = getattr(self, 'show_wizards', 1)
        data['show_message_icons'] = getattr(self, 'show_message_icons', 1)
        data['allow_anon_names'] = getattr(self, 'allow_anon_names', '')
        data['allow_signatures'] = getattr(self, 'allow_signatures', 1)
        data['allowSubscription'] = self.allowSubscription()
        data['allowTopicSubscription'] = self.allowTopicSubscription()
        data['quickreply'] = getattr(self, 'quickreply_form', '')
        data['hits_counter'] = getattr(self, 'hits_counter', 1)
        data['topic_page_size'] = getattr(self, 'topic_page_size', 20)
        data['forum_page_size'] = getattr(self, 'forum_page_size', 20)
        data['view_mode'] = getattr(self, 'view_mode', 'flat')
        data['view_mode_selectable'] = getattr(self, 'view_mode_selectable', 1)
        data['sort_mode_selectable'] = getattr(self, 'sort_mode_selectable', 1)
        data['isModerated'] = self.isModerated()
        data['contact_admin'] = getattr(self, 'contact_admin', 1)

        #sort_mode = data['sort_mode']
        #view_mode = data['view_mode']
        tool.setView(uid, 'globals', data)

        return data

    def view_getData(self, request):
        pass

    def view_getViewable(self):
        pass

    def view_getMenu(self):
        request = self.REQUEST
        
        f_data = request.f_data
        g_data = request.cmfboard_data
        url = f_data['url']
        
        session = request.get('SESSION', {})

        data = {}

        # view mode
        default = f_data['view_mode']
        if f_data['view_mode_selectable']:
            name = '%s_viewmode'%f_data['uid']
            if session.has_key(name):
                view_mode = session[name]
            else:
                view_mode = g_data['member'].getProperty('fc_forum_vm', default)
            if view_mode not in ('flat','thread'):
                view_mode = default
        else:
            view_mode = default
        data['view_mode'] = view_mode

        if _checkPermission(AddTopic, self):
            data['contact_admin'] = f_data['contact_admin']
        else:
            data['contact_admin'] = 0

        # new content creation links
        contents = {}
        if _checkPermission(AddTopic, self):
            contents['topic'] = 1

        if _checkPermission(AddPoll, self):
            contents['poll'] = 1

        if _checkPermission(AddAnnouncement, self):
            contents['announce'] = 1
        data['contents'] = contents
        data['forums_tree'] = get_forums_tree(self, g_data['portal'])

        actions = []

        if _checkPermission(ManageForum, self):
            actions.append(
                {'title': 'Edit',
                 'url': '%s/base_edit'%url})
            actions.append(
                {'title': 'Permissions',
                 'url': '%s/forum_user_permissions'%url})
            
            if hasattr(g_data['portal'], 'portal_subscriptions'):
                actions.append(
                    {'title': 'Subscribers',
                     'url': '%s/pt_subscribers_form'%url})

        data['actions'] = actions
        
        return data
